#pragma once
#include <vector>

class BSpline {
public:
	BSpline(void);
	~BSpline(void);

public:
	void addControlPoint(double points[3]);
	void addControlPoint(double x, double y, double z);
	
	void bspline(int degree, double output[61][3], int num_output);
	double blend(int pointIndex, int degree, int *u, double intervall);
	void compute_intervals(int *u, int degree);
	void computePoint(int *u, int degree, double interval, double *output);

private:
	struct BSplinePoint {
		double x;
		double y;
		double z;
	};

	typedef std::vector<BSplinePoint*>				BSPointArray;
	typedef std::vector<BSplinePoint*>::iterator	BSPointArrayIterator;

	BSPointArray controlPoints;

	// controlpoints -1
	int nofControlPoints;
};
