#include "stdafx.h"
#include "box.h"


Box::Box(float c[8][3], float *m, float *k)
{
	side1[0] = 0; side1[1] = 1; side1[2] = 2; side1[3] = 3;
	side2[0] = 4; side2[1] = 5; side2[2] = 1; side2[3] = 0;
	side3[0] = 5; side3[1] = 4; side3[2] = 7; side3[3] = 6;
	side4[0] = 6; side4[1] = 7; side4[2] = 3; side4[3] = 2;
	side5[0] = 1; side5[1] = 5; side5[2] = 6; side5[3] = 2;
	side6[0] = 4; side6[1] = 0; side6[2] = 3; side6[3] = 7;

	float d1[3]; float d2[3];
	corners[0][0] = c[0][0];
	corners[0][1] = c[0][1];
	corners[0][2] = c[0][2];
	corners[1][0] = c[1][0];
	corners[1][1] = c[1][1];
	corners[1][2] = c[1][2];
	corners[2][0] = c[2][0];
	corners[2][1] = c[2][1];
	corners[2][2] = c[2][2];
	corners[3][0] = c[3][0];
	corners[3][1] = c[3][1];
	corners[3][2] = c[3][2];
	corners[4][0] = c[4][0];
	corners[4][1] = c[4][1];
	corners[4][2] = c[4][2];
	corners[5][0] = c[5][0];
	corners[5][1] = c[5][1];
	corners[5][2] = c[5][2];
	corners[6][0] = c[6][0];
	corners[6][1] = c[6][1];
	corners[6][2] = c[6][2];
	corners[7][0] = c[7][0];
	corners[7][1] = c[7][1];
	corners[7][2] = c[7][2];
	bmat[0] = m[0];
	bmat[1] = m[1];
	bmat[2] = m[2];
	kd = k[0];
	ks = k[1];
	kr = k[2];
	index = k[3];

	d1[0] = corners[side1[3]][0] - corners[side1[0]][0];
	d1[1] = corners[side1[3]][1] - corners[side1[0]][1];
	d1[2] = corners[side1[3]][2] - corners[side1[0]][2];
	d2[0] = corners[side1[1]][0] - corners[side1[0]][0];
	d2[1] = corners[side1[1]][1] - corners[side1[0]][1];
	d2[2] = corners[side1[1]][2] - corners[side1[0]][2];
	crossp(d1,d2,n1);

	d1[0] = corners[side2[3]][0] - corners[side2[0]][0];
	d1[1] = corners[side2[3]][1] - corners[side2[0]][1];
	d1[2] = corners[side2[3]][2] - corners[side2[0]][2];
	d2[0] = corners[side2[1]][0] - corners[side2[0]][0];
	d2[1] = corners[side2[1]][1] - corners[side2[0]][1];
	d2[2] = corners[side2[1]][2] - corners[side2[0]][2];
	crossp(d1,d2,n2);

	d1[0] = corners[side3[3]][0] - corners[side3[0]][0];
	d1[1] = corners[side3[3]][1] - corners[side3[0]][1];
	d1[2] = corners[side3[3]][2] - corners[side3[0]][2];
	d2[0] = corners[side3[1]][0] - corners[side3[0]][0];
	d2[1] = corners[side3[1]][1] - corners[side3[0]][1];
	d2[2] = corners[side3[1]][2] - corners[side3[0]][2];
	crossp(d1,d2,n3);

	d1[0] = corners[side4[3]][0] - corners[side4[0]][0];
	d1[1] = corners[side4[3]][1] - corners[side4[0]][1];
	d1[2] = corners[side4[3]][2] - corners[side4[0]][2];
	d2[0] = corners[side4[1]][0] - corners[side4[0]][0];
	d2[1] = corners[side4[1]][1] - corners[side4[0]][1];
	d2[2] = corners[side4[1]][2] - corners[side4[0]][2];
	crossp(d1,d2,n4);

	d1[0] = corners[side5[3]][0] - corners[side5[0]][0];
	d1[1] = corners[side5[3]][1] - corners[side5[0]][1];
	d1[2] = corners[side5[3]][2] - corners[side5[0]][2];
	d2[0] = corners[side5[1]][0] - corners[side5[0]][0];
	d2[1] = corners[side5[1]][1] - corners[side5[0]][1];
	d2[2] = corners[side5[1]][2] - corners[side5[0]][2];
	crossp(d1,d2,n5);

	d1[0] = corners[side6[3]][0] - corners[side6[0]][0];
	d1[1] = corners[side6[3]][1] - corners[side6[0]][1];
	d1[2] = corners[side6[3]][2] - corners[side6[0]][2];
	d2[0] = corners[side6[1]][0] - corners[side6[0]][0];
	d2[1] = corners[side6[1]][1] - corners[side6[0]][1];
	d2[2] = corners[side6[1]][2] - corners[side6[0]][2];
	crossp(d1,d2,n6);
}

Box::~Box(void) {}


void Box::translate(float *t){
	int i;
	for (i = 0; i < 8; i++){
		corners[i][0] += t[0];
		corners[i][1] += t[1];
		corners[i][2] += t[2];
	}
}

void Box::transform(float m[3][3]){
	int i;
	for (i = 0; i < 8; i++){
		float corners0 = corners[i][0]; float corners1 = corners[i][1]; float corners2 = corners[i][2]; 
		corners[i][0] = m[0][0]*corners0+m[0][1]*corners1+m[0][2]*corners2;
		corners[i][1] = m[1][0]*corners0+m[1][1]*corners1+m[1][2]*corners2;
		corners[i][2] = m[2][0]*corners0+m[2][1]*corners1+m[2][2]*corners2;
	}
	float n10 = n1[0]; float n11 = n1[1]; float n12 = n1[2]; 
	n1[0] = m[0][0]*n10+m[0][1]*n11+m[0][2]*n12;
	n1[1] = m[1][0]*n10+m[1][1]*n11+m[1][2]*n12;
	n1[2] = m[2][0]*n10+m[2][1]*n11+m[2][2]*n12;
	float n20 = n2[0]; float n21 = n2[1]; float n22 = n2[2]; 
	n2[0] = m[0][0]*n20+m[0][1]*n21+m[0][2]*n22;
	n2[1] = m[1][0]*n20+m[1][1]*n21+m[1][2]*n22;
	n2[2] = m[2][0]*n20+m[2][1]*n21+m[2][2]*n22;
	float n30 = n3[0]; float n31 = n3[1]; float n32 = n3[2]; 
	n3[0] = m[0][0]*n30+m[0][1]*n31+m[0][2]*n32;
	n3[1] = m[1][0]*n30+m[1][1]*n31+m[1][2]*n32;
	n3[2] = m[2][0]*n30+m[2][1]*n31+m[2][2]*n32;
	float n40 = n4[0]; float n41 = n4[1]; float n42 = n4[2]; 
	n4[0] = m[0][0]*n40+m[0][1]*n41+m[0][2]*n42;
	n4[1] = m[1][0]*n40+m[1][1]*n41+m[1][2]*n42;
	n4[2] = m[2][0]*n40+m[2][1]*n41+m[2][2]*n42;
	float n50 = n5[0]; float n51 = n5[1]; float n52 = n5[2]; 
	n5[0] = m[0][0]*n50+m[0][1]*n51+m[0][2]*n52;
	n5[1] = m[1][0]*n50+m[1][1]*n51+m[1][2]*n52;
	n5[2] = m[2][0]*n50+m[2][1]*n51+m[2][2]*n52;
	float n60 = n6[0]; float n61 = n6[1]; float n62 = n6[2]; 
	n6[0] = m[0][0]*n60+m[0][1]*n61+m[0][2]*n62;
	n6[1] = m[1][0]*n60+m[1][1]*n61+m[1][2]*n62;
	n6[2] = m[2][0]*n60+m[2][1]*n61+m[2][2]*n62;
}

bool Box::inside_square(int *side, float *p){
	// is p inside square abcd? input as:
	// a  b
	// d  c
	float a[3]; float b[3]; float c[3]; float d[3];
	float dir1[3]; float dir2[3]; float dir3[3]; float dir4[3];
	float pdir[3];

	a[0] = corners[side[0]][0];
	a[1] = corners[side[0]][1];
	a[2] = corners[side[0]][2];
	b[0] = corners[side[1]][0];
	b[1] = corners[side[1]][1];
	b[2] = corners[side[1]][2];
	c[0] = corners[side[2]][0];
	c[1] = corners[side[2]][1];
	c[2] = corners[side[2]][2];
	d[0] = corners[side[3]][0];
	d[1] = corners[side[3]][1];
	d[2] = corners[side[3]][2];

	dir1[0] = b[0] - a[0];
	dir1[1] = b[1] - a[1];
	dir1[2] = b[2] - a[2];
	dir2[0] = -dir1[0];
	dir2[1] = -dir1[1];
	dir2[2] = -dir1[2];
	dir3[0] = d[0] - a[0];
	dir3[1] = d[1] - a[1];
	dir3[2] = d[2] - a[2];
	dir4[0] = -dir3[0];
	dir4[1] = -dir3[1];
	dir4[2] = -dir3[2];

	pdir[0] = p[0] - a[0];
	pdir[1] = p[1] - a[1];
	pdir[2] = p[2] - a[2];

	if ((dot(dir1,pdir)>0.0)&&(dot(dir3,pdir)>0.0)){
		pdir[0] = p[0] - b[0];
		pdir[1] = p[1] - b[1];
		pdir[2] = p[2] - b[2];

		if (dot(dir2,pdir)>0.0){
			pdir[0] = p[0] - d[0];
			pdir[1] = p[1] - d[1];
			pdir[2] = p[2] - d[2];

			if (dot(dir4,pdir)>0.0){
				return true;
			}
		}
	}
	return false;
}


float Box::cut_plane(int *side, float *n, float *pos, float *dir){
	// does the line originating at pos in direction dir cut the given side of the "box"?
	// if yes, return t, if no return t = 10000;
	float t; float hit[3];
	float *point;
	
	if (dot(dir,n)!= 0){
		point = corners[side[0]];
		t = (dot(corners[side[0]],n)-dot(pos,n))/dot(dir,n);
	}else{
		return 10000;
	}

	hit[0] = pos[0] + t*dir[0];
	hit[1] = pos[1] + t*dir[1];
	hit[2] = pos[2] + t*dir[2];

	if (inside_square(side, hit)&&(t > 0.0)){
		return t;
	}else{	
		return 10000;
	}
}


float Box::t(float *p,float *d){

	float tmin = 10000; float t;

	t = cut_plane(side1, n1, p, d);
	if (t < tmin){
		tmin = t;
		active_n = n1;
	}
		
	t = cut_plane(side2, n2, p, d);
	if (t < tmin){
		tmin = t;
		active_n = n2;
	}

	t = cut_plane(side3, n3, p, d);
	if (t < tmin){
		tmin = t;
		active_n = n3;
	}

	t = cut_plane(side4, n4, p, d);
	if (t < tmin){
		tmin = t;
		active_n = n4;
	}

	t = cut_plane(side5, n5, p, d);
	if (t < tmin){
		tmin = t;
		active_n = n5;
	}

	t = cut_plane(side6, n6, p, d);
	if (t < tmin){
		tmin = t;
		active_n = n6;
	}

	if (tmin < 10000){
		return tmin;
	}else{
		return 10000;
	}

}

float Box::tex(float *p,float *d, float *uv){
	return 0.0;
}

bool Box::textured(){
	return false;
}

bool Box::bump_mapping(){
	return false;
}

int Box::get_texture_index(void){
	return 0;
}

int Box::get_bump_index(void){
	return 0;
}

float Box::cut_dist(float *p,float *d){

	// to do: special cases

	float t1 = 10000; float t2 = 10000; float t;

	t = cut_plane(side1, n1, p, d);
	if (t < 10000){
		if (t < t1){
			t2 = t1;
			t1 = t;
		}else{
			t2 = t;
		}
	}
		
	t = cut_plane(side2, n2, p, d);
	if (t < 10000){
		if (t < t1){
			t2 = t1;
			t1 = t;
		}else{
			t2 = t;
		}
	}

	t = cut_plane(side3, n3, p, d);
	if (t < 10000){
		if (t < t1){
			t2 = t1;
			t1 = t;
		}else{
			t2 = t;
		}
	}

	t = cut_plane(side4, n4, p, d);
	if (t < 10000){
		if (t < t1){
			t2 = t1;
			t1 = t;
		}else{
			t2 = t;
		}
	}

	t = cut_plane(side5, n5, p, d);
	if (t < 10000){
		if (t < t1){
			t2 = t1;
			t1 = t;
		}else{
			t2 = t;
		}
	}

	t = cut_plane(side6, n6, p, d);
	if (t < 10000){
		if (t < t1){
			t2 = t1;
			t1 = t;
		}else{
			t2 = t;
		}
	}

	if ((t1 < 10000)&&(t2 < 10000)){
		return abs(t2-t1);
	}else{
		return -1;
	}

}


void Box::normal(float *hit, float *n){
	n[0] = active_n[0];
	n[1] = active_n[1];
	n[2] = active_n[2];
}

void Box::partial_derivatives(float *uv, float *duv){
	
}

void Box::material(float *m){
	m[0] = bmat[0];
	m[1] = bmat[1];
	m[2] = bmat[2];
}

float Box::get_kd(void){
	return kd;
}

float Box::get_ks(void){
	return ks;
}

float Box::get_kr(void){
	return kr;
}

float Box::get_index(void){
	return index;
}

