#pragma once
#include "primitive.h"

class Box : public Primitive
{
public:
	Box(float[8][3], float*, float*);
	~Box(void);

private:
	float corners[8][3];
	float bmat[3];
	int side1[4]; int side2[4]; int side3[4];
	int side4[4]; int side5[4]; int side6[4];
	float n1[3]; float n2[3]; float n3[3]; float n4[3]; float n5[3]; float n6[3];
	float *active_n;
	float kd, ks, kr;
	float index;
	
	bool inside_square(int *side, float *p);
	float cut_plane(int *side, float *n, float *pos, float *dir);

public:
	// override virtual functions
	virtual float t(float *p,float *d);
	virtual float tex(float *p,float *d, float *uv);
	virtual float cut_dist(float *p,float *d);
	virtual void transform(float m[3][3]);
	virtual void translate(float *t);
	virtual void normal(float *hit, float *n);
	virtual void partial_derivatives(float *uv, float *duv);
	virtual void material(float *m);
	virtual float get_kd(void);
	virtual float get_ks(void);
	virtual float get_kr(void);
	virtual float get_index(void);
	virtual int get_texture_index(void);
	virtual int get_bump_index(void);
	virtual bool textured(void);
	virtual bool bump_mapping(void);
};
