#include "StdAfx.h"
#include "cylinder.h"


void Cylinder::translate(float *t){
	c1[0] += t[0];
	c1[1] += t[1];
	c1[2] += t[2];
	c2[0] += t[0];
	c2[1] += t[1];
	c2[2] += t[2];
}

void Cylinder::transform(float m[3][3]){
	float c10 = c1[0]; float c11 = c1[1]; float c12 = c1[2];
	float c20 = c2[0]; float c21 = c2[1]; float c22 = c2[2];
	c1[0] = m[0][0]*c10+m[0][1]*c11+m[0][2]*c12;
	c1[1] = m[1][0]*c10+m[1][1]*c11+m[1][2]*c12;
	c1[2] = m[2][0]*c10+m[2][1]*c11+m[2][2]*c12;
	c2[0] = m[0][0]*c20+m[0][1]*c21+m[0][2]*c22;
	c2[1] = m[1][0]*c20+m[1][1]*c21+m[1][2]*c22;
	c2[2] = m[2][0]*c20+m[2][1]*c21+m[2][2]*c22;
}

float Cylinder::t(float *p,float *d){

	float ax[3]; float a,b,c; float k[3]; float ak[3]; float ad[3];
	float con1[3]; float con2[3]; float hit[3];
	float t = 10000; float tend = 10000; float t1 = 10000; float t2 = 10000;
	ax[0] = c2[0] - c1[0]; ax[1] = c2[1] - c1[1]; ax[2] = c2[2] - c1[2]; 
	norm(ax);
	k[0] = p[0] - c1[0]; k[1] = p[1] - c1[1]; k[2] = p[2] - c1[2];
	ak[0] = ax[0] * dot(ax,k); ak[1] = ax[1] * dot(ax,k); ak[2] = ax[2] * dot(ax,k); 
	ad[0] = ax[0] * dot(ax,d); ad[1] = ax[1] * dot(ax,d); ad[2] = ax[2] * dot(ax,d); 
	con1[0] = p[0]-ak[0]-c1[0]; con1[1] = p[1]-ak[1]-c1[1]; con1[2] = p[2]-ak[2]-c1[2]; 
	con2[0] = d[0]-ad[0]; con2[1] = d[1]-ad[1]; con2[2] = d[2]-ad[2]; 

	// cut "ends" of cylinder
	if (dot(ax,d) != 0){
		t1 = (dot(c1,ax)-dot(p,ax))/dot(ax,d);
		hit[0] = p[0]+t1*d[0]; hit[1] = p[1]+t1*d[1]; hit[2] = p[2]+t1*d[2];
		if ((dot(hit,hit) - 2*dot(hit,c1) + dot(c1,c1) > r*r)||t1<0.0){
			t1 = 10000;
		}
	}
	if (dot(ax,d) != 0){
		t2 = (dot(c2,ax)-dot(p,ax))/dot(ax,d);
		hit[0] = p[0]+t2*d[0]; hit[1] = p[1]+t2*d[1]; hit[2] = p[2]+t2*d[2];
		if ((dot(hit,hit) - 2*dot(hit,c2) + dot(c2,c2) > r*r)||t2<0.0){
			t2 = 10000;
		}
	}

	if (t2 < t1){
		tend = t2;
	}else{
		tend = t1;
	}

	// cut cylinder
	a = dot(con2,con2);
	b = 2*dot(con1,con2);
	c = dot(con1,con1) - r*r;

	if ((b*b-4*a*c)>=0.0){

		t1 = (-b + sqrt(b*b-4*a*c))/(2.0*a);
		t2 = (-b - sqrt(b*b-4*a*c))/(2.0*a);
		if ((t1>0.0)||(t2>0.0)){

			if (t1<0.0){
				t = t2;
			}else if(t2<0.0){
				t = t1;
			}else if(t1<t2){
				t = t1;
			}else{
				t = t2;
			}	
			hit[0] = p[0]+t*d[0]; hit[1] = p[1]+t*d[1]; hit[2] = p[2]+t*d[2];
			con1[0] = hit[0] - c1[0]; con1[1] = hit[1] - c1[1]; con1[2] = hit[2] - c1[2]; 
			con2[0] = hit[0] - c2[0]; con2[1] = hit[1] - c2[1]; con2[2] = hit[2] - c2[2]; 
			if ((dot(con1,ax) > 0.0)&&(dot(con2,ax) < 0.0)){
				if (t < tend){
					return t;
				}
			}
		}
	}
	return tend;
}

float Cylinder::tex(float *p,float *d, float *uv){
	return 0.0;
}

bool Cylinder::textured(){
	return false;
}

bool Cylinder::bump_mapping(){
	return false;
}

int Cylinder::get_texture_index(void){
	return 0;
}

int Cylinder::get_bump_index(void){
	return 0;
}

float Cylinder::cut_dist(float *p,float *d){

	float ax[3]; float a,b,c; float k[3]; float ak[3]; float ad[3];
	float con1[3]; float con2[3]; float hit[3];
	float t = 10000; float tend = 10000; float t1 = 10000; float t2 = 10000; float t3 = 10000; float t4 = 10000;
	float tmin = 10000; float tmax = -10000;
	ax[0] = c2[0] - c1[0]; ax[1] = c2[1] - c1[1]; ax[2] = c2[2] - c1[2]; 
	norm(ax);
	k[0] = p[0] - c1[0]; k[1] = p[1] - c1[1]; k[2] = p[2] - c1[2];
	ak[0] = ax[0] * dot(ax,k); ak[1] = ax[1] * dot(ax,k); ak[2] = ax[2] * dot(ax,k); 
	ad[0] = ax[0] * dot(ax,d); ad[1] = ax[1] * dot(ax,d); ad[2] = ax[2] * dot(ax,d); 
	con1[0] = p[0]-ak[0]-c1[0]; con1[1] = p[1]-ak[1]-c1[1]; con1[2] = p[2]-ak[2]-c1[2]; 
	con2[0] = d[0]-ad[0]; con2[1] = d[1]-ad[1]; con2[2] = d[2]-ad[2]; 

	// cut "ends" of cylinder
	if (dot(ax,d) != 0){
		t1 = (dot(c1,ax)-dot(p,ax))/dot(ax,d);
		hit[0] = p[0]+t1*d[0]; hit[1] = p[1]+t1*d[1]; hit[2] = p[2]+t1*d[2];
		if ((dot(hit,hit) - 2*dot(hit,c1) + dot(c1,c1) > r*r)||t1<0.0){
			t1 = 10000;
		}
	}
	if (dot(ax,d) != 0){
		t2 = (dot(c2,ax)-dot(p,ax))/dot(ax,d);
		hit[0] = p[0]+t2*d[0]; hit[1] = p[1]+t2*d[1]; hit[2] = p[2]+t2*d[2];
		if ((dot(hit,hit) - 2*dot(hit,c2) + dot(c2,c2) > r*r)||t2<0.0){
			t2 = 10000;
		}
	}

	// cut cylinder
	a = dot(con2,con2);
	b = 2*dot(con1,con2);
	c = dot(con1,con1) - r*r;

	if ((b*b-4*a*c)>=0.0){

		t3 = (-b + sqrt(b*b-4*a*c))/(2.0*a);
		t4 = (-b - sqrt(b*b-4*a*c))/(2.0*a);
	
		hit[0] = p[0]+t3*d[0]; hit[1] = p[1]+t3*d[1]; hit[2] = p[2]+t3*d[2];
		con1[0] = hit[0] - c1[0]; con1[1] = hit[1] - c1[1]; con1[2] = hit[2] - c1[2]; 
		con2[0] = hit[0] - c2[0]; con2[1] = hit[1] - c2[1]; con2[2] = hit[2] - c2[2]; 
		if (!((dot(con1,ax) > 0.0)&&(dot(con2,ax) < 0.0))){
			t3 = 10000;
		}

		hit[0] = p[0]+t4*d[0]; hit[1] = p[1]+t4*d[1]; hit[2] = p[2]+t4*d[2];
		con1[0] = hit[0] - c1[0]; con1[1] = hit[1] - c1[1]; con1[2] = hit[2] - c1[2]; 
		con2[0] = hit[0] - c2[0]; con2[1] = hit[1] - c2[1]; con2[2] = hit[2] - c2[2]; 
		if (!((dot(con1,ax) > 0.0)&&(dot(con2,ax) < 0.0))){
			t4 = 10000;
		}
	}

	if ((t1 == 10000)&&(t2 == 10000)&&(t3 == 10000)&&(t4 == 10000)){
		return -1;
	}
	if (t1 <= tmin){
		tmin = t1;
	} 
	if (t2 <= tmin){
		tmin = t2;
	}
	if (t3 <= tmin){
		tmin = t3;
	}
	if (t4 <= tmin){
		tmin = t4;
	}
	if ((t1 >= tmax)&&(t1 != 10000)){
		tmax = t1;
	} 
	if ((t2 >= tmax)&&(t2 != 10000)){
		tmax = t2;
	}
	if ((t3 >= tmax)&&(t3 != 10000)){
		tmax = t3;
	}
	if ((t4 >= tmax)&&(t4 != 10000)){
		tmax = t4;
	}

	if ((tmin != 10000)&&(tmax != -10000)){
		return (tmax-tmin);
	}else{
		return -1;
	}
}


void Cylinder::normal(float *hit, float *n){

	float axis[3]; float k1[3]; float k2[3]; 

	k1[0] = hit[0] - c1[0]; k1[1] = hit[1] - c1[1]; k1[2] = hit[2] - c1[2];
	k2[0] = hit[0] - c2[0]; k2[1] = hit[1] - c2[1]; k2[2] = hit[2] - c2[2];
	axis[0] = c2[0] - c1[0]; axis[1] = c2[1] - c1[1]; axis[2] = c2[2] - c1[2];
	norm(axis);

	if (abs(dot(k1,axis)) < 0.0001){
		n[0] = -axis[0]; n[1] = -axis[1]; n[2] = -axis[2]; 
	}else if (abs(dot(k2,axis)) < 0.0001){
		n[0] = axis[0]; n[1] = axis[1]; n[2] = axis[2]; 
	}else{
		n[0] = hit[0] - (c1[0] + axis[0]*dot(k1,axis));
		n[1] = hit[1] - (c1[1] + axis[1]*dot(k1,axis));
		n[2] = hit[2] - (c1[2] + axis[2]*dot(k1,axis));
	}
}

void Cylinder::partial_derivatives(float *uv, float *duv){
	
}


void Cylinder::material(float *m){
	m[0] = mat[0];
	m[1] = mat[1];
	m[2] = mat[2];
}

float Cylinder::get_kd(void){
	return kd;
}

float Cylinder::get_ks(void){
	return ks;
}

float Cylinder::get_kr(void){
	return kr;
}

float Cylinder::get_index(void){
	return index;
}

Cylinder::Cylinder(float rad, float *pos1, float *pos2, float *m, float *k)
{
	r = rad;
	c1[0] = pos1[0];
	c1[1] = pos1[1];
	c1[2] = pos1[2];
	c2[0] = pos2[0];
	c2[1] = pos2[1];
	c2[2] = pos2[2];
	mat[0] = m[0];
	mat[1] = m[1];
	mat[2] = m[2];
	kd = k[0];
	ks = k[1];
	kr = k[2];
	index = k[3];
}

Cylinder::~Cylinder(void)
{
}

