#include "StdAfx.h"
#include ".\infplane.h"

float Infplane::t(float *p,float *d){

	float t;
	norm(normv);

	if (dot(d,normv) != 0){
		t = (dot(point,normv)-dot(p,normv))/dot(d,normv);
		if (t>0.0){
			return t;
		}
	}

	return 10000;

}

float Infplane::tex(float *p,float *d, float *uv){
	return 0.0;
}

float Infplane::cut_dist(float *p,float *d){
	return -1;
}	

bool Infplane::textured(){
	return false;
}

int Infplane::get_texture_index(void){
	return 0;
}

int Infplane::get_bump_index(void){
	return 0;
}

bool Infplane::bump_mapping(){
	return false;
}

void Infplane::translate(float *t){
	point[0] += t[0]; point[1] += t[1]; point[2] += t[2];
}

void Infplane::transform(float m[3][3]){
	float p0 = point[0]; float p1 = point[1]; float p2 = point[2]; 
	point[0] = m[0][0]*p0+m[0][1]*p1+m[0][2]*p2;
	point[1] = m[1][0]*p0+m[1][1]*p1+m[1][2]*p2;
	point[2] = m[2][0]*p0+m[2][1]*p1+m[2][2]*p2;
	float n0 = normv[0]; float n1 = normv[1]; float n2 = normv[2]; 
	normv[0] = m[0][0]*n0+m[0][1]*n1+m[0][2]*n2;
	normv[1] = m[1][0]*n0+m[1][1]*n1+m[1][2]*n2;
	normv[2] = m[2][0]*n0+m[2][1]*n1+m[2][2]*n2;
}

void Infplane::normal(float *hit, float *n){
	n[0] = normv[0];
	n[1] = normv[1];
	n[2] = normv[2];
}

void Infplane::partial_derivatives(float *uv, float *duv){
	
}

void Infplane::material(float *m){
	m[0] = mat[0];
	m[1] = mat[1];
	m[2] = mat[2];
}

float Infplane::get_kd(void){
	return kd;
}

float Infplane::get_ks(void){
	return ks;
}

float Infplane::get_kr(void){
	return kr;
}

float Infplane::get_index(void){
	return index;
}

Infplane::Infplane(float *q, float *n, float *m, float *k)
{
	point[0] = q[0]; point[1] = q[1]; point[2] = q[2]; 
	mat[0] = m[0];
	mat[1] = m[1];
	mat[2] = m[2];
	kd = k[0];
	ks = k[1];
	kr = k[2];
	index = k[3];
	normv[0] = n[0]; normv[1] = n[1]; normv[2] = n[2]; 
}

Infplane::~Infplane(void)
{
}

// position
float Infplane::minX() {
	return - 4096;
}

float Infplane::maxX() {
	return + 4096;
}

float Infplane::minY() {
	return - 4096;
}

float Infplane::maxY() {
	return + 4096;
}

float Infplane::minZ() {
	return - 4096;
}

float Infplane::maxZ() {
	return + 4096;
}
