#pragma once
#include "primitive.h"

class Infplane : public Primitive
{

private:
	float point[3];
	float kd; float ks; float kr;
	float index;
	float mat[3];
	float normv[3]; 

public:
	virtual float t(float *p,float *d);
	virtual float tex(float *p,float *d, float *uv);
	virtual float cut_dist(float *p,float *d);
	virtual void normal(float *hit, float *n);
	virtual void partial_derivatives(float *uv, float *duv);
	virtual void material(float *m);
	virtual float get_kd(void);
	virtual float get_ks(void);
	virtual float get_kr(void);
	virtual void translate(float *t);
	virtual void transform(float m[3][3]);
	virtual float get_index(void);
	virtual int get_texture_index(void);
	virtual int get_bump_index(void);
	virtual bool textured(void);
	virtual bool bump_mapping(void);

public:
	Infplane(float*, float*, float*, float*);
	~Infplane(void);

	// position
	virtual float minX();
	virtual float maxX();
	virtual float minY();
	virtual float maxY();
	virtual float minZ();
	virtual float maxZ();
};
