// ray.cpp : Defines the entry point for the console application.
#include "stdafx.h"
#include "ray.h"
#include "kdTree.h"
#include "vector.h"

//#define w							1024
//#define h							576
//#define w							800
//#define h							450
//#define w							200
//#define h							100
#define w							100
#define h							 50
#define BOOL_ANTIALIASING			false
#define LIGHTS_COUNT				1

// coefficients for ambient, diffuse and specular part; added coefficient for reflection... 
// (originally not part of the equation, but may be useful..?)
float ka;
int e, steps;
float epsilon = 0.001;

bool antialiasing = false;

// view specification
float eye[3];
float center[3];
float up[3];

float aspect = float(w)/float(h);
float fovy;
float znear;

float length_x;
float length_y;

// lights
float lights[2][6];
float Ia[3];
int lcount = LIGHTS_COUNT;



vector<Primitive*>		primitives;

map<string, rayTexture*>	mTex;
vector<rayTexture*>			vTex;

// window support
HDC hdc = NULL;

void set_scene() {
	float smat[3] = {1.0,0.5,0.25};
	float sk[4]   = {0.8,0.5,0.0,0.0};

	float spos1[3] = {2.0,0.0,0.0};
	primitives.push_back(new Sphere(1.0,spos1,smat,sk));

	float spos2[3] = {0.0,0.0,0.0};
	primitives.push_back(new Sphere(1.0,spos2,smat,sk));

	float spos5[3] = {-2.0,0.0,0.0};
	primitives.push_back(new Sphere(1.0,spos5,smat,sk));

	float spos3[3] = {0.0,1.41421,1.41421};
	primitives.push_back(new Sphere(1.0,spos3,smat,sk));

	float spos4[3] = {0.0,-1.41421,1.41421};
	primitives.push_back(new Sphere(1.0,spos4,smat,sk));


	//float spos1[3] = {1.6,-0.2,-2.5};
	//float smat1[3] = {1.0,1.0,1.0};
	//float sk1[4] = {0.5,0.0,0.0,1.0};
	////Sphere *s1 = new Sphere(0.6,spos1,smat1,sk1);
	////primitives.push_back(s1);

	//float c1pos1[3] = {1.3,-0.7,-2.0};
	//float c1pos2[3] = {1.3,1.2,-2.0};
	//float c1mat[3] = {1.0,1.0,1.0};
	//float c1k[4] = {0.7,0.0,0.0,1.0};
	//Cylinder *c1 = new Cylinder(0.5,c1pos1,c1pos2,c1mat,c1k);
	//primitives.push_back(c1);

	//float spos2[3] = {-0.5,0.0,-4.0};
	//float smat2[3] = {1.0,1.0,1.0};
	////float sk2[4] = {0.0,0.0,1.2,1.1};
	//float sk2[4] = {0.8,0.0,0.0,1.0};
	//float up[3] = {0.0,1.0,0.0};
	//float right[3] = {1.0,0.0,0.0};
	//Sphere *s2 = new Sphere(1.0,spos2,smat2,sk2,up,right,2,3);
	//primitives.push_back(s2);

	//float po2[3] = {-2.4,0.0,0.0};
	//float n2[3] = {1.0,0.0,0.0};
	//float pmat2[3] = {1.0,1.0,1.0};
	//float pk2[4] = {0.5,0.0,0.0,1.0};
	//Infplane *p2 = new Infplane(po2,n2,pmat2,pk2);
	//primitives.push_back(p2);

	//float po3[3] = {2.4,0.0,0.0};
	//float n3[3] = {-1.0,0.0,0.0};
	//float pmat3[3] = {1.0,1.0,1.0};
	//float pk3[4] = {0.5,0.0,0.0,1.0};
	//Infplane *p3 = new Infplane(po3,n3,pmat3,pk3);
	//primitives.push_back(p3);

	//float po5[3] = {0.0,0.0,2.45};
	//float n5[3] = {0.0,0.0,-1.0};
	//float pmat5[3] = {1.0,1.0,1.0};
	//float pk5[4] = {0.5,0.0,0.0,1.0};
	//Infplane *p5 = new Infplane(po5,n5,pmat5,pk5);
	//primitives.push_back(p5);

	//float po6[3] = {0.0,1.9,0.0};
	//float n6[3] = {0.0,-1.0,0.0};
	//float pmat6[3] = {1.0,1.0,1.0};
	//float pk6[4] = {0.5,0.0,0.0,1.0};
	//Infplane *p6 = new Infplane(po6,n6,pmat6,pk6);
	//primitives.push_back(p6);


	//float t1q1[3] = {-2.5,-1.2,-5.5};
	//float t1q2[3] = {2.5,-1.2,-5.5};
	//float t1q3[3] = {2.5,-1.2,2.5};
	//float t1tex1[2] = {0.0,0.0};
	//float t1tex2[2] = {1.0,0.0};
	//float t1tex3[2] = {1.0,1.0};
	//float t1no1[3] = {0.0,1.0,0.0};
	//float t1no2[3] = {0.0,1.0,0.0};
	//float t1no3[3] = {0.0,1.0,0.0};
	//float t1tmat[3] = {0.3,0.3,0.3};
	//float t1tk[4] = {1.5,0.0,0.0,1.0};
	//Triangle *t1 = new Triangle(t1q1,t1q2,t1q3,t1tex1,t1tex2,t1tex3,0,-1,t1no1,t1no2,t1no3,t1tmat,t1tk);
	//primitives.push_back(t1);

	//float t2q1[3] = {-2.5,-1.2,-5.5};
	//float t2q2[3] = {2.5,-1.2,2.5};
	//float t2q3[3] = {-2.5,-1.2,2.5};
	//float t2tex1[2] = {0.0,0.0};
	//float t2tex2[2] = {1.0,1.0};
	//float t2tex3[2] = {0.0,1.0};
	//float t2no1[3] = {0.0,1.0,0.0};
	//float t2no2[3] = {0.0,1.0,0.0};
	//float t2no3[3] = {0.0,1.0,0.0};
	//float t2tmat[3] = {0.3,0.3,0.3};
	//float t2tk[4] = {1.5,0.0,0.0,1.0};
	//Triangle *t2 = new Triangle(t2q1,t2q2,t2q3,t2tex1,t2tex2,t2tex3,0,-1,t2no1,t2no2,t2no3,t2tmat,t2tk);
	//primitives.push_back(t2);

	//float t3q1[3] = {-2.5,-1.2,-5.5};
	//float t3q2[3] = {2.5,-1.2,-5.5};
	//float t3q3[3] = {-2.5,2.0,-5.5};
	//float t3tex1[2] = {0.0,0.0};
	//float t3tex2[2] = {1.0,0.0};
	//float t3tex3[2] = {0.0,1.0};
	//float t3no1[3] = {0.0,1.0,0.0};
	//float t3no2[3] = {0.0,1.0,0.0};
	//float t3no3[3] = {0.0,1.0,0.0};
	//float t3tmat[3] = {0.3,0.3,0.3};
	//float t3tk[4] = {1.5,0.0,0.0,1.0};
	//Triangle *t3 = new Triangle(t3q1,t3q2,t3q3,t3tex1,t3tex2,t3tex3,1,-1,t3no1,t3no2,t3no3,t3tmat,t3tk);
	//primitives.push_back(t3);

	//float t4q1[3] = {-2.5,2.0,-5.5};
	//float t4q2[3] = {2.5,2.0,-5.5};
	//float t4q3[3] = {2.5,-1.2,-5.5};
	//float t4tex1[2] = {0.0,1.0};
	//float t4tex2[2] = {1.0,1.0};
	//float t4tex3[2] = {1.0,0.0};
	//float t4no1[3] = {0.0,1.0,0.0};
	//float t4no2[3] = {0.0,1.0,0.0};
	//float t4no3[3] = {0.0,1.0,0.0};
	//float t4tmat[3] = {0.3,0.3,0.3};
	//float t4tk[4] = {1.5,0.0,0.0,1.0};
	//Triangle *t4 = new Triangle(t4q1,t4q2,t4q3,t4tex1,t4tex2,t4tex3,1,-1,t4no1,t4no2,t4no3,t4tmat,t4tk);
	//primitives.push_back(t4);
}

float dotp(float *a, float *b){
	return a[0]*b[0]+a[1]*b[1]+a[2]*b[2];
}

void normalize(float *v){
	float norm = sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
	v[0] = v[0]/norm;
	v[1] = v[1]/norm;
	v[2] = v[2]/norm;
}

void cross(float *a, float *b, float *c){
	c[0] = a[1]*b[2] - a[2]*b[1];
	c[1] = a[2]*b[0] - a[0]*b[2];
	c[2] = a[0]*b[1] - a[1]*b[0];
}

void get_texture_value(float *uv, int index, int *color){
	// get texture
	rayTexture *texture = vTex[index];

	int width  = texture->Width;
	int height = texture->Height;

	// it is RGB or RGBA?
	int components = 3;
	if (texture->Type == rayRGBA)
		components = 4;

	// get location
	int x = floor(uv[0] * width);
	int y = floor(uv[1] * height);

	// wrap around if needed
	while (x < 0)
		x += vTex[index]->Width;

	while (x > vTex[index]->Width)
		x -= vTex[index]->Width;

	while (y < 0)
		y += vTex[index]->Height;

	while (y > vTex[index]->Height)
		y -= vTex[index]->Height;

	// get color value
	color[0] = texture->rawTexture[components * ((y * width) + x) +0];
	color[1] = texture->rawTexture[components * ((y * width) + x) +1];
	color[2] = texture->rawTexture[components * ((y * width) + x) +2];
}

void get_bump_map_values(float *uv, int bindex, int *colors, int *wh){
	// get texture
	rayTexture *texture = vTex[bindex];

	int width  = texture->Width;
	int height = texture->Height;

	wh[0] = width;
	wh[1] = height;

	// it is RGB or RGBA?
	int components = 3;
	if (texture->Type == rayRGBA) {
		components = 4;
	}

	// get location
	int x = floor(uv[0] * width);
	int y = floor(uv[1] * height);

	int x1 = (x-1 >= 0)      ? x-1 : 0;
	int x2 = (x+1 <= width)  ? x+1 : width;
	int y1 = (y-1 >= 0)      ? y-1 : 0;
	int y2 = (y+1 <= height) ? y+1 : height;

	// get color value
	colors[0] = texture->rawTexture[components * ((y1 * width) + x2)];
	colors[1] = texture->rawTexture[components * ((y1 * width) + x1)];
	colors[2] = texture->rawTexture[components * ((y2 * width) + x2)];
	colors[3] = texture->rawTexture[components * ((y2 * width) + x1)];
}

int load_texture(char *texture) {
	// check if texture already loaded
//	if (mTex[texture] != NULL) {
//		return mTex[texture]->TextureID;
//	}
//	else {
		rayTexture *structtex = new rayTexture();
		rayTextureLoader loader;
		loader.SetTextureFilter(raytxBilinear);
		loader.LoadTextureFromDisk(texture, structtex);

		structtex->TextureID = vTex.size();
		vTex.push_back(structtex);

		return structtex->TextureID;
//	}
}

void translate_scene(float *t){

	for(vector<Primitive*>::iterator iter = primitives.begin(); iter != primitives.end(); ++iter) {
		(*iter)->translate(t);
	}

	for (int i = 0; i < lcount; i++){
		lights[i][0] += t[0];
		lights[i][1] += t[1];
		lights[i][2] += t[2];
	}
}

void transform_scene(float m[3][3]){

	for(vector<Primitive*>::iterator iter = primitives.begin(); iter != primitives.end(); ++iter) {
		(*iter)->transform(m);
	}

	for (int i = 0; i < lcount; i++){
		float l0 = lights[i][0]; float l1 = lights[i][1]; float l2 = lights[i][2];
		lights[i][0] = m[0][0]*l0+m[0][1]*l1+m[0][2]*l2;
		lights[i][1] = m[1][0]*l0+m[1][1]*l1+m[1][2]*l2;
		lights[i][2] = m[2][0]*l0+m[2][1]*l1+m[2][2]*l2;
	}
}

void transform_coords() {
	float t[3];
	t[0] = -eye[0]; t[1] = -eye[1]; t[2] = -eye[2];
	translate_scene(t);
	normalize(up);
	float m[3][3];
	float x[3];
	float z[3]; z[0] = center[0] - eye[0]; z[1] = center[1] - eye[1]; z[2] = center[2] - eye[2];
	normalize(z);
	m[1][0] = up[0]; m[1][1] = up[1]; m[1][2] = up[2];
	m[2][0] = z[0]; m[2][1] = z[1] ; m[2][2] = z[2];
	cross(z,up,x);
	normalize(x);
	m[0][0] = x[0]; m[0][1] = x[1]; m[0][2] = x[2];
	transform_scene(m);

	length_y = 2*znear*sinf(fovy/2.0)/cosf(fovy/2.0);
	length_x = length_y*aspect;
}


float inlight(float *hit, float *light){

	float dir[3];
	float eps1[3]; float eps2[3];
	float t,dist,d;
	float kr = 0;
	float att = 1.0;
	float tmin = 10000;
	int i;
	dir[0] = light[0] - hit[0];
	dir[1] = light[1] - hit[1];
	dir[2] = light[2] - hit[2];
	dist = sqrt(dotp(dir,dir));
	normalize(dir);
	eps1[0] = hit[0] + epsilon*dir[0];
	eps1[1] = hit[1] + epsilon*dir[1];
	eps1[2] = hit[2] + epsilon*dir[2];

	for(vector<Primitive*>::iterator iter = primitives.begin(); iter != primitives.end(); ++iter) {

		t = (*iter)->t(eps1,dir);

		if ((t < tmin)&&(kr == 0.0)){
			kr = (*iter)->get_kr();
			tmin = t;
		}
	}

	if (!(tmin <= dist)){
		
		for(vector<Primitive*>::iterator iter = primitives.begin(); iter != primitives.end(); ++iter) {
			t = (*iter)->t(eps1,dir);

			if (t < dist){
				d = (*iter)->cut_dist(hit,dir);
				kr = (*iter)->get_kr();
				att = att*kr;
				if (d != -1){
					att = att*exp(-0.2*d*d);
				}
			}
		}
	}else{
		return 0.0;
	}

	return att;
}



int *shoot_ray(float *pos, float *dir, int step, int *color, float currind, bool inside){

	int *refl; int *refr; float att;
	int reflcolor[3]; int refrcolor[3];
	float hit[3]; float l[3]; float half[3]; float epshit1[3];
	float mat[3]; float n[3]; float refldir[3]; float epshit2[3]; float refrdir[3];
	float kd,ks,kr,index;
	float t,temp1,temp2;
	float tmin = 10000; float uv[2]; float uvmin[2]; float duv[6]; float pu[3]; float pv[3];
	int i;
	bool cut = false; bool textured = false; bool bump; int bindex;

	if(step >= steps){
		color[0] = 0; color[1] = 0; color[2] = 0;
		return color;
	}

	// Primitive that is hit
	Primitive *prim;

	for(vector<Primitive*>::iterator iter = primitives.begin(); iter != primitives.end(); ++iter) {
		if ((*iter)->textured() || (*iter)->bump_mapping()){
			t = (*iter)->tex(pos, dir, uvmin);
		//}else if ((*iter)->bump_mapping()){
		//	t = (*iter)->tex(pos, dir, uvmin);
		}else{
			t = (*iter)->t(pos,dir);
		}

		if (t < tmin){
			cut = true;
			textured = (*iter)->textured();
			bump = (*iter)->bump_mapping();

			uv[0] = uvmin[0];
			uv[1] = uvmin[1];

			tmin = t;
			prim = *iter;
		}
	}


	if(cut){
		hit[0] = pos[0] + tmin*dir[0];
		hit[1] = pos[1] + tmin*dir[1];
		hit[2] = pos[2] + tmin*dir[2];

		// new OO Code
		prim->normal(hit,n);
		normalize(n);
		prim->material(mat);

		if (textured) {
			// '-1' == no texture used...
			if (prim->get_texture_index() != -1) {
				int c[3];
				get_texture_value(uv, prim->get_texture_index(), c);
				mat[0] = float(c[0])/255.0;
				mat[1] = float(c[1])/255.0;
				mat[2] = float(c[2])/255.0;
			}
			else {
				prim->material(mat);
			}
		}

		if (bump) {
			prim->partial_derivatives(uv,duv);
			pu[0] = duv[0]; pu[1] = duv[1]; pu[2] = duv[2]; 
			pv[0] = duv[3]; pv[1] = duv[4]; pv[2] = duv[5];
			float bu; float bv; float crossu[3]; float crossv[3]; int colors[4]; int wh[2];
			bindex = prim->get_bump_index(); 
			get_bump_map_values(uv, bindex, colors, wh);
			bu = ((colors[0]-colors[1]+colors[2]-colors[3])/(255.0*300.0))*(wh[0]/4.0);
			bv = ((colors[3]-colors[1]+colors[2]-colors[0])/(255.0*300.0))*(wh[1]/4.0);
			cross(n,pu,crossu); cross(n,pv,crossv);
			n[0] = n[0] + bu*crossu[0] + bv*crossv[0];
			n[1] = n[1] + bu*crossu[1] + bv*crossv[1];
			n[2] = n[2] + bu*crossu[2] + bv*crossv[2];
		}

		kd = prim->get_kd();
		ks = prim->get_ks();
		kr = prim->get_kr();
		index = prim->get_index();

		// determine ambient part of light
		//if (!(textured)){
			color[0] = Ia[0]*ka*mat[0];
			color[1] = Ia[1]*ka*mat[1];
			color[2] = Ia[2]*ka*mat[2];
		//}

		// evaluate diffuse and specular part of light
		if (!inside&&((kd != 0.0)||(ks != 0.0))){
			for (i=0;i<lcount;i++){
				att = inlight(hit,lights[i]);
				if (att > 1.0){
					att = 1.0;
				}
				if (att){
					l[0] = lights[i][0] - hit[0];
					l[1] = lights[i][1] - hit[1];
					l[2] = lights[i][2] - hit[2];
					normalize(l);
					half[0] = l[0] - dir[0];
					half[1] = l[1] - dir[1];
					half[2] = l[2] - dir[2];
					normalize(half);
					temp1 = ks*powf(dotp(half,n),e);
					if (temp1 < 0.0){
						temp1 = 0.0;
					}
					temp2 = kd*dotp(n,l);
					if (temp2 < 0.0){
						temp2 = 0.0;
					}
					if (color[0] + lights[i][3]*(temp2*mat[0]+temp1)*att > 255.0){
						color[0] = 255.0;
					}else{
						color[0] += lights[i][3]*(temp2*mat[0]+temp1)*att;
					}
					if (color[1] + lights[i][4]*(temp2*mat[1]+temp1)*att > 255.0){
						color[1] = 255.0;
					}else{
						color[1] += lights[i][4]*(temp2*mat[1]+temp1)*att;
					}
					if (color[2] + lights[i][5]*(temp2*mat[2]+temp1)*att > 255.0){
						color[2] = 255.0;
					}else{
					color[2] += lights[i][5]*(temp2*mat[2]+temp1)*att;
					}
				}
			}
		}

		dir[0] = -dir[0];
		dir[1] = -dir[1];
		dir[2] = -dir[2];
		refldir[0] = 2*n[0]*dotp(n,dir)-dir[0];
		refldir[1] = 2*n[1]*dotp(n,dir)-dir[1];
		refldir[2] = 2*n[2]*dotp(n,dir)-dir[2];
		epshit1[0] = hit[0] + epsilon*refldir[0];
		epshit1[1] = hit[1] + epsilon*refldir[1];
		epshit1[2] = hit[2] + epsilon*refldir[2];

		if (kr != 0.0){
			temp1 = dotp(n,dir);
			if (!((currind>index)&&(acos(temp1) > asin(index/currind)))){
				if (currind == index){
					refrdir[0] = -dir[0];
					refrdir[1] = -dir[1];
					refrdir[2] = -dir[2];
				}else{
					temp2 = sqrt(1-(currind/index)*(currind/index)*(1-temp1*temp1));
					refrdir[0] = -(currind/index)*dir[0] + (-temp2 + (currind/index)*temp1)*n[0];
					refrdir[1] = -(currind/index)*dir[1] + (-temp2 + (currind/index)*temp1)*n[1];
					refrdir[2] = -(currind/index)*dir[2] + (-temp2 + (currind/index)*temp1)*n[2];
					normalize(refrdir);
				}
				epshit2[0] = hit[0] + epsilon*refrdir[0];
				epshit2[1] = hit[1] + epsilon*refrdir[1];
				epshit2[2] = hit[2] + epsilon*refrdir[2];
				refr = new int[3];
				shoot_ray(epshit2,refrdir,step+1,refr,index,!inside);
				refrcolor[0] = refr[0]; refrcolor[1] = refr[1]; refrcolor[2] = refr[2]; 
				delete[] refr;
				// test for overflow
				if (color[0] + refrcolor[0]*kr > 255.0){
					color[0] = 255;
				}else{
					color[0] = color[0] + refrcolor[0]*kr;
				}
				if (color[1] + refrcolor[1]*kr > 255.0){
					color[1] = 255;
				}else{
					color[1] = color[1] + refrcolor[1]*kr;
				}
				if (color[2] + refrcolor[2]*kr > 255.0){
					color[2] = 255;
				}else{
					color[2] = color[2] + refrcolor[2]*kr;
				}
			}
		}
		if (!inside){
			refl = new int[3];
			if (ks != 0.0){
				shoot_ray(epshit1,refldir,step+1,refl,index,inside);
			}
			reflcolor[0] = refl[0]; reflcolor[1] = refl[1]; reflcolor[2] = refl[2]; 
			delete[] refl;

			// test for overflow
			if (color[0] + reflcolor[0]*ks > 255.0){
				color[0] = 255;
			}else{
				color[0] = color[0] + reflcolor[0]*ks;
			}
			if (color[1] + reflcolor[1]*ks > 255.0){
				color[1] = 255;
			}else{
				color[1] = color[1] + reflcolor[1]*ks;
			}
			if (color[2] + reflcolor[2]*ks > 255.0){
				color[2] = 255;
			}else{
				color[2] = color[2] + reflcolor[2]*ks;
			}
		}
		
	}else{
		// Background color
		color[0] = 64; color[1] = 0; color[2] = 0;
	}

	return color;
}

void array_to_bmp (char bmp[], int y, int x, char *filename){

	char fileheader[14];
	char infoheader[40];
	int size = h*x*3;
	int offset = 54;

	fileheader[0] = 'B';
	fileheader[1] = 'M';	
	fileheader[2] = size;
	fileheader[3] = size>>8;
	fileheader[4] = size>>16;
	fileheader[5] = size>>24;
	fileheader[6] = 0;
	fileheader[7] = 0;
	fileheader[8] = 0;
	fileheader[9] = 0;
	fileheader[10] = offset;
	fileheader[11] = offset>>8;
	fileheader[12] = offset>>16;
	fileheader[13] = offset>>24;

	infoheader[0] = 40;
	infoheader[1] = 0;
	infoheader[2] = 0;
	infoheader[3] = 0;
	infoheader[4] = x;
	infoheader[5] = x>>8;
	infoheader[6] = x>>16;
	infoheader[7] = x>>24;
	infoheader[8] = y;
	infoheader[9] = y>>8;
	infoheader[10] = y>>16;
	infoheader[11] = y>>24;
	infoheader[12] = 1;
	infoheader[13] = 0;
	infoheader[14] = 24;
	infoheader[15] = 0;
	infoheader[16] = 0;
	infoheader[17] = 0;
	infoheader[18] = 0;
	infoheader[19] = 0;
	infoheader[20] = 0;
	infoheader[21] = 0;
	infoheader[22] = 0;
	infoheader[23] = 0;
	infoheader[24] = 0;
	infoheader[25] = 0;
	infoheader[26] = 0;
	infoheader[27] = 0;
	infoheader[28] = 0;
	infoheader[29] = 0;
	infoheader[30] = 0;
	infoheader[31] = 0;
	infoheader[32] = 0;
	infoheader[33] = 0;
	infoheader[34] = 0;
	infoheader[35] = 0;
	infoheader[36] = 0;
	infoheader[37] = 0;
	infoheader[38] = 0;
	infoheader[39] = 0;

	FILE *pic;
	int i;
	
	pic = fopen (filename, "wb");
	if (pic != NULL){
		for (i = 0; i < 14; i++){
			fputc (fileheader[i],pic);
		}
		for (i = 0; i < 40; i++){
			fputc (infoheader[i],pic);
		}
		for (i = 0; i < x*y*3; i++){
			fputc (bmp[i],pic);
		}
		fclose(pic);
	}
}

void draw_raytracer(char *filename){

	char *bmp = new char[w*h*3];
	int *color;
	float dir[3]; float dir1[3]; float dir2[3]; float dir3[3]; float dir4[3]; float dir5[3];    
	float pos[3] = {0.0,0.0,0.0};
	int u,v; int i = 0;

	// specify filename if none available
	if (filename == NULL) {
		filename = "picture.bmp";
	}

	// setup a kdTree over the whole scene
	Primitive *k = new kdTree(primitives);
	primitives.clear();
	primitives.push_back(k);

	if (!antialiasing){
		for (v = 0; v < h; v++){
			for (u = 0; u < w; u++){
				int *color = new int[3];

				dir[0] = float(u)/float(w)*length_x - length_x/2.0;
				dir[1] = float(v)/float(h)*length_y - length_y/2.0;
				dir[2] = znear;
				normalize(dir);
				color = shoot_ray(pos,dir,0,color,1.0,false);
				bmp[w*v*3+u*3] = char(color[2]);
				bmp[w*v*3+u*3+1] = char(color[1]);
				bmp[w*v*3+u*3+2] = char(color[0]);

//				COLORREF c = RGB(color[0], color[1], color[2]);
//				COLORREF white = RGB(255,255,255);
//				SetPixel(hdc, u, h-v, c);
//				SetPixel(hdc, u, h-v-1, white);

				delete[] color;
			}

			printf("%d\n", v);
		}
	}else{
		for (v = 0; v < h; v++){
			for (u = 0; u < w; u++){
				int *color1 = new int[3];
				int *color2 = new int[3];
				int *color3 = new int[3];
				int *color4 = new int[3];
				int *color5 = new int[3];

				dir1[0] = float(u)/float(w)*length_x - length_x/2.0;
				dir1[1] = float(v)/float(h)*length_y - length_y/2.0;
				dir1[2] = znear;
				dir2[0] = (float(u)+0.25)/float(w)*length_x - length_x/2.0;
				dir2[1] = (float(v)+0.25)/float(h)*length_y - length_y/2.0;
				dir2[2] = znear;
				dir3[0] = (float(u)+0.25)/float(w)*length_x - length_x/2.0;
				dir3[1] = (float(v)-0.25)/float(h)*length_y - length_y/2.0;
				dir3[2] = znear;
				dir4[0] = (float(u)-0.25)/float(w)*length_x - length_x/2.0;
				dir4[1] = (float(v)+0.25)/float(h)*length_y - length_y/2.0;
				dir4[2] = znear;
				dir5[0] = (float(u)-0.25)/float(w)*length_x - length_x/2.0;
				dir5[1] = (float(v)-0.25)/float(h)*length_y - length_y/2.0;
				dir5[2] = znear;
				normalize(dir1);
				normalize(dir2);
				normalize(dir3);
				normalize(dir4);
				normalize(dir5);
				color1 = shoot_ray(pos,dir1,0,color1,1.0,false);
				color2 = shoot_ray(pos,dir2,0,color2,1.0,false);
				color3 = shoot_ray(pos,dir3,0,color3,1.0,false);
				color4 = shoot_ray(pos,dir4,0,color4,1.0,false);
				color5 = shoot_ray(pos,dir5,0,color5,1.0,false);
				color1[0] = 0.2*(color1[0]+color2[0]+color3[0]+color4[0]+color5[0]);
				color1[1] = 0.2*(color1[1]+color2[1]+color3[1]+color4[1]+color5[1]);
				color1[2] = 0.2*(color1[2]+color2[2]+color3[2]+color4[2]+color5[2]);
				bmp[w*v*3+u*3] = char(color1[2]);
				bmp[w*v*3+u*3+1] = char(color1[1]);
				bmp[w*v*3+u*3+2] = char(color1[0]);

				COLORREF c = RGB(color1[0], color1[1], color1[2]);
				SetPixel(hdc, u, h-v, c);

				delete[] color1; delete[] color2; delete[] color3; delete[] color4; delete[] color5;
			}

			printf("%d\n", v);
		}
	}

	array_to_bmp (bmp, h, w, filename);
	delete[] bmp;
}

void init_raytracer(void) {

	eye[0] = 0.0; eye[1] = 0.0; eye[2] = 5;
	center[0] = 0.0; center[1] = 0.0; center[2] = 0.0;
	up[0] = 0.5; up[1] = 0.5; up[2] = 0.0;
	fovy = 0.8; znear = 1.0;

	lights[0][0] = 25.5; lights[0][1] = 25.5; lights[0][2] = -25.5;
	lights[0][3] = 255; lights[0][4] = 255; lights[0][5] = 255;

	lights[1][0] = 2.3; lights[1][1] = 1.8; lights[1][2] = -8.3;
	lights[1][3] = 255; lights[1][4] = 255; lights[1][5] = 255;

	ka = 0.1; 
	e = 25; steps = 8;
	Ia[0] = 255; Ia[1] = 255; Ia[2] = 255; 

	antialiasing = BOOL_ANTIALIASING;
}

/* set perspective */
void rayPerspective(int _fovy, float _zNear) {
	fovy = _fovy/180.0f * 3.14159265358979;
	znear = _zNear;
}

void rayPerspective(float _fovy, float _zNear) {
	fovy = _fovy;
	znear = _zNear;
}

/* set Look at vectors */
void rayLookAt(float eyeX, float eyeY, float eyeZ,
			   float centerX, float centerY, float centerZ,
			   float upX, float upY, float upZ) {
	eye[0] = eyeX;
	eye[1] = eyeY;
	eye[2] = eyeZ;

	center[0] = centerX;
	center[1] = centerY;
	center[2] = centerZ;

	Vector3d upVec(upX, upY, upZ);
	Vector3d eye(center[0] - eye[0], center[1] - eye[1], center[2] - eye[2]);

	Vector3d vec;
	vec = eye.CrossProduct(upVec);
	vec = vec.CrossProduct(eye);

	vec.normalize();

	up[0] = vec.x;
	up[1] = vec.y;
	up[2] = vec.z;
}

void reset_raytracer() {
	for(vector<Primitive*>::iterator iter = primitives.begin(); iter != primitives.end(); ++iter) {
		delete *iter;
	}

	primitives.clear();
	init_raytracer();
}

HWND open_window(HINSTANCE hInstance);
LRESULT CALLBACK MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);

void launch() {
	init_raytracer();
	set_scene();
	transform_coords();
	draw_raytracer();
}

//int main(int argc, _TCHAR* argv[])
//{
//	create_window();
//	launch();
//}




/**
 * Open a window where we can draw the picture while rendering
 */
int create_window() {
	HINSTANCE hInstance = (HINSTANCE)GetModuleHandle(NULL);
	HWND hWnd = open_window(hInstance);

	if (hWnd == 0) {
		MessageBox(0, "Couldn't create window", "ray", MB_OK);
		return 0;
	}

	hdc = GetDC(hWnd);

	MSG msg;

	//while(GetMessage(&msg, NULL, 0, 0)) {
	//	TranslateMessage(&msg);
	//	DispatchMessage(&msg);
	//}

	return 0;
}

HWND open_window(HINSTANCE hInstance) {
	WNDCLASSEX wndClass;

	wndClass.cbSize = sizeof(WNDCLASSEX);
	wndClass.style  = CS_DBLCLKS | CS_OWNDC |
	                  CS_HREDRAW | CS_VREDRAW;
	wndClass.lpfnWndProc   = MessageHandler;
	wndClass.cbClsExtra    = 0;
	wndClass.cbWndExtra    = 0;
	wndClass.hInstance     = hInstance;
	wndClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndClass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndClass.lpszMenuName  = NULL;
	wndClass.lpszClassName = "WindowClass";
	wndClass.hIcon         = LoadIcon(NULL, IDI_WINLOGO);
	wndClass.hIconSm       = LoadIcon(NULL, IDI_WINLOGO);

	RegisterClassEx(&wndClass);
	return CreateWindowEx(NULL, "WindowClass", "ray", WS_OVERLAPPEDWINDOW | WS_VISIBLE, 0, 0, w, h, NULL, NULL, hInstance, NULL);
}

LRESULT CALLBACK MessageHandler(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {
	switch(msg) {
		case WM_CREATE:
			//launch();
			return 0;
		case WM_LBUTTONDOWN:
			launch();
			break;
		case WM_CLOSE:
			exit(0);
			return 0;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}