#pragma once
#include "primitive.h"

class Sphere : public Primitive
{
public:
	Sphere(float rad, float pos[3], float *m, float *k);
	Sphere(float radius, float position[3], float *m, float *k, float *up, float *right, int tindex, int bindex);
	~Sphere(void);

private:
	float c[3]; float up[3]; float right[3];
	float r,kd,ks,kr; bool is_textured; bool has_bump_map;
	float index; int tindex; int bindex;
	float mat[3];

public:
	// override virtual functions
	virtual float t(float *p,float *d);
	virtual float tex(float *p,float *d, float *uv);
	virtual float cut_dist(float *p,float *d);
	virtual void transform(float m[3][3]);
	virtual void translate(float *t);
	virtual void normal(float *hit, float *n);
	virtual void partial_derivatives(float *uv, float *duv);
	virtual void material(float *m);
	virtual float get_kd(void);
	virtual float get_ks(void);
	virtual float get_kr(void);
	virtual float get_index(void);
	virtual int get_texture_index(void);
	virtual int get_bump_index(void);
	virtual bool textured(void);
	virtual bool bump_mapping(void);

	// position
	virtual float minX();
	virtual float maxX();
	virtual float minY();
	virtual float maxY();
	virtual float minZ();
	virtual float maxZ();
};
