#include "StdAfx.h"
#include "triangle.h"

float Triangle::t(float *p,float *d){

	float n[3]; float d1[3]; float d2[3]; float d3[3]; float hit[3]; float c[3];
	float t = 10000;
	float s1, s2, s3;
	d1[0] = p3[0] - p2[0]; d1[1] = p3[1] - p2[1]; d1[2] = p3[2] - p2[2]; 
	d2[0] = p1[0] - p2[0]; d2[1] = p1[1] - p2[1]; d2[2] = p1[2] - p2[2]; 
	crossp(d1,d2,n);
	norm(n);
	if (dot(d,n)!= 0){
		t = (dot(p1,n)-dot(p,n))/dot(d,n);
		if (t>0.0){
			// inside test
			hit[0] = p[0] + t*d[0]; hit[1] = p[1] + t*d[1]; hit[2] = p[2] + t*d[2]; 

			d1[0] = p1[0] - hit[0]; d1[1] = p1[1] - hit[1]; d1[2] = p1[2] - hit[2];
			d2[0] = p2[0] - hit[0]; d2[1] = p2[1] - hit[1]; d2[2] = p2[2] - hit[2];
			d3[0] = p3[0] - hit[0]; d3[1] = p3[1] - hit[1]; d3[2] = p3[2] - hit[2];

			crossp(d2,d3,c);
			s1 = dot(c,n)/2.0;
			crossp(d3,d1,c);
			s2 = dot(c,n)/2.0;
			crossp(d1,d2,c);
			s3 = dot(c,n)/2.0;

			if ((s1>=0.0)&&(s2>=0.0)&&(s3>=0.0)){
				if (t>0.0){
					t_normal[0] = (s1*n1[0]+s2*n2[0]+s3*n3[0])/(s1+s2+s3);
					t_normal[1] = (s1*n1[1]+s2*n2[1]+s3*n3[1])/(s1+s2+s3);
					t_normal[2] = (s1*n1[2]+s2*n2[2]+s3*n3[2])/(s1+s2+s3);
					return t;
				}
			}
		}
	}

	return 10000;

}

float Triangle::tex(float *p,float *d, float *uv){

	float n[3]; float d1[3]; float d2[3]; float d3[3]; float hit[3]; float c[3];
	float t = 10000;
	float s1, s2, s3;
	d1[0] = p3[0] - p2[0]; d1[1] = p3[1] - p2[1]; d1[2] = p3[2] - p2[2]; 
	d2[0] = p1[0] - p2[0]; d2[1] = p1[1] - p2[1]; d2[2] = p1[2] - p2[2]; 
	crossp(d1,d2,n);
	norm(n);
	if (dot(d,n)!= 0){
		t = (dot(p1,n)-dot(p,n))/dot(d,n);
		if (t>0.0){
			// inside test
			hit[0] = p[0] + t*d[0]; hit[1] = p[1] + t*d[1]; hit[2] = p[2] + t*d[2]; 

			d1[0] = p1[0] - hit[0]; d1[1] = p1[1] - hit[1]; d1[2] = p1[2] - hit[2];
			d2[0] = p2[0] - hit[0]; d2[1] = p2[1] - hit[1]; d2[2] = p2[2] - hit[2];
			d3[0] = p3[0] - hit[0]; d3[1] = p3[1] - hit[1]; d3[2] = p3[2] - hit[2];

			crossp(d2,d3,c);
			s1 = dot(c,n)/2.0;
			crossp(d3,d1,c);
			s2 = dot(c,n)/2.0;
			crossp(d1,d2,c);
			s3 = dot(c,n)/2.0;

			if ((s1>=0.0)&&(s2>=0.0)&&(s3>=0.0)){
				if (t>0.0){
					t_normal[0] = (s1*n1[0]+s2*n2[0]+s3*n3[0])/(s1+s2+s3);
					t_normal[1] = (s1*n1[1]+s2*n2[1]+s3*n3[1])/(s1+s2+s3);
					t_normal[2] = (s1*n1[2]+s2*n2[2]+s3*n3[2])/(s1+s2+s3);
					uv[0] = (s1*tex1[0]+s2*tex2[0]+s3*tex3[0])/(s1+s2+s3);
					uv[1] = (s1*tex1[1]+s2*tex2[1]+s3*tex3[1])/(s1+s2+s3);
					return t;
				}
			}
		}
	}

	return 10000;

}

bool Triangle::textured(){
	return is_textured;
}

bool Triangle::bump_mapping(){
	return has_bump_map;
}

float Triangle::cut_dist(float *p,float *d){
	return -1;
}	

void Triangle::translate(float *t){
	p1[0] += t[0]; p1[1] += t[1]; p1[2] += t[2];
	p2[0] += t[0]; p2[1] += t[1]; p2[2] += t[2];
	p3[0] += t[0]; p3[1] += t[1]; p3[2] += t[2];
}

void Triangle::transform(float m[3][3]){
	float p10 = p1[0]; float p11 = p1[1]; float p12 = p1[2]; 
	p1[0] = m[0][0]*p10+m[0][1]*p11+m[0][2]*p12;
	p1[1] = m[1][0]*p10+m[1][1]*p11+m[1][2]*p12;
	p1[2] = m[2][0]*p10+m[2][1]*p11+m[2][2]*p12;
	float p20 = p2[0]; float p21 = p2[1]; float p22 = p2[2]; 
	p2[0] = m[0][0]*p20+m[0][1]*p21+m[0][2]*p22;
	p2[1] = m[1][0]*p20+m[1][1]*p21+m[1][2]*p22;
	p2[2] = m[2][0]*p20+m[2][1]*p21+m[2][2]*p22;
	float p30 = p3[0]; float p31 = p3[1]; float p32 = p3[2]; 
	p3[0] = m[0][0]*p30+m[0][1]*p31+m[0][2]*p32;
	p3[1] = m[1][0]*p30+m[1][1]*p31+m[1][2]*p32;
	p3[2] = m[2][0]*p30+m[2][1]*p31+m[2][2]*p32;
	float n10 = n1[0]; float n11 = n1[1]; float n12 = n1[2]; 
	n1[0] = m[0][0]*n10+m[0][1]*n11+m[0][2]*n12;
	n1[1] = m[1][0]*n10+m[1][1]*n11+m[1][2]*n12;
	n1[2] = m[2][0]*n10+m[2][1]*n11+m[2][2]*n12;
	float n20 = n2[0]; float n21 = n2[1]; float n22 = n2[2]; 
	n2[0] = m[0][0]*n20+m[0][1]*n21+m[0][2]*n22;
	n2[1] = m[1][0]*n20+m[1][1]*n21+m[1][2]*n22;
	n2[2] = m[2][0]*n20+m[2][1]*n21+m[2][2]*n22;
	float n30 = n3[0]; float n31 = n3[1]; float n32 = n3[2]; 
	n3[0] = m[0][0]*n30+m[0][1]*n31+m[0][2]*n32;
	n3[1] = m[1][0]*n30+m[1][1]*n31+m[1][2]*n32;
	n3[2] = m[2][0]*n30+m[2][1]*n31+m[2][2]*n32;
}

void Triangle::normal(float *hit, float *n){
	n[0] = t_normal[0];
	n[1] = t_normal[1];
	n[2] = t_normal[2];
}

void Triangle::partial_derivatives(float *uv, float *duv){
	float a = tex1[0] - tex3[0]; float b = tex2[0] - tex3[0];
	float c = tex1[1] - tex3[1]; float d = tex2[1] - tex3[1];
	float det = a*d - b*c;
	float q1[3]; float q2[3];
	q1[0] = p1[0] - p3[0]; q1[1] = p1[1] - p3[1]; q1[2] = p1[2] - p3[2]; 
	q2[0] = p2[0] - p3[0]; q2[1] = p2[1] - p3[1]; q2[2] = p2[2] - p3[2]; 
	duv[0] = (d*q1[0]-c*q2[0])/det;
	duv[1] = (d*q1[1]-c*q2[1])/det;
	duv[2] = (d*q1[2]-c*q2[2])/det;
	duv[3] = (a*q2[0]-b*q1[0])/det;
	duv[4] = (a*q2[1]-b*q1[1])/det;
	duv[5] = (a*q2[2]-b*q1[2])/det;
}

void Triangle::material(float *m){
	m[0] = mat[0];
	m[1] = mat[1];
	m[2] = mat[2];
}

float Triangle::get_kd(void){
	return kd;
}

float Triangle::get_ks(void){
	return ks;
}

float Triangle::get_kr(void){
	return kr;
}

float Triangle::get_index(void){
	return index;
}

int Triangle::get_texture_index(void){
	return tindex;
}

int Triangle::get_bump_index(void){
	return bindex;
}

Triangle::Triangle(float *q1, float *q2, float *q3, float *no1, float *no2, float *no3, float *m, float *k)
{
	p1[0] = q1[0]; p1[1] = q1[1]; p1[2] = q1[2]; 
	p2[0] = q2[0]; p2[1] = q2[1]; p2[2] = q2[2]; 
	p3[0] = q3[0]; p3[1] = q3[1]; p3[2] = q3[2]; 
	mat[0] = m[0];
	mat[1] = m[1];
	mat[2] = m[2];
	kd = k[0];
	ks = k[1];
	kr = k[2];
	index = k[3];
	n1[0] = no1[0]; n1[1] = no1[1]; n1[2] = no1[2]; 
	n2[0] = no2[0]; n2[1] = no2[1]; n2[2] = no2[2]; 
	n3[0] = no3[0]; n3[1] = no3[1]; n3[2] = no3[2]; 

	is_textured = false;
	has_bump_map = false;
}

Triangle::Triangle(float *q1, float *q2, float *q3, float *t1, float *t2, float *t3, int texindex, int btex, float *no1, float *no2, float *no3, float *m, float *k)
{
	p1[0] = q1[0]; p1[1] = q1[1]; p1[2] = q1[2]; 
	p2[0] = q2[0]; p2[1] = q2[1]; p2[2] = q2[2]; 
	p3[0] = q3[0]; p3[1] = q3[1]; p3[2] = q3[2]; 
	mat[0] = m[0];
	mat[1] = m[1];
	mat[2] = m[2];
	kd = k[0];
	ks = k[1];
	kr = k[2];
	index = k[3];
	n1[0] = no1[0]; n1[1] = no1[1]; n1[2] = no1[2]; 
	n2[0] = no2[0]; n2[1] = no2[1]; n2[2] = no2[2]; 
	n3[0] = no3[0]; n3[1] = no3[1]; n3[2] = no3[2]; 
	tex1[0] = t1[0]; tex1[1] = t1[1];
	tex2[0] = t2[0]; tex2[1] = t2[1];
	tex3[0] = t3[0]; tex3[1] = t3[1];
	tindex = texindex;
	bindex = btex;
	if (texindex == -1){
		is_textured = false;
	}else{
		is_textured = true;
	}
	if (btex == -1){
		has_bump_map = false;
	}else{
		has_bump_map = true;
	}
}

Triangle::~Triangle(void)
{
}

// position
float Triangle::minX() {
	float xmin = p1[0];
	if (p2[0] < xmin)				xmin = p2[0];
	if (p3[0] < xmin)				xmin = p3[0];

	return xmin;
}

float Triangle::maxX() {
	float xmax = p1[0];
	if (p2[0] > xmax)				xmax = p2[0];
	if (p3[0] > xmax)				xmax = p3[0];

	return xmax;
}

float Triangle::minY() {
	float ymin = p1[1];
	if (p2[1] < ymin)				ymin = p2[1];
	if (p3[1] < ymin)				ymin = p3[1];

	return ymin;
}

float Triangle::maxY() {
	float ymax = p1[1];
	if (p2[1] > ymax)				ymax = p2[1];
	if (p3[1] > ymax)				ymax = p3[1];

	return ymax;
}

float Triangle::minZ() {
	float zmin = p1[2];
	if (p2[2] < zmin)				zmin = p2[2];
	if (p3[2] < zmin)				zmin = p3[2];

	return zmin;
}

float Triangle::maxZ() {
	float zmax = p1[2];
	if (p2[2] > zmax)				zmax = p2[2];
	if (p3[2] > zmax)				zmax = p3[2];

	return zmax;
}
