#pragma once
#include "primitive.h"

class Triangle : public Primitive
{
public:
	Triangle(float *q1, float *q2, float *q3, float *no1, float *no2, float *no3, float *m, float *k);
	Triangle(float *q1, float *q2, float *q3, float *t1, float *t2, float *t3, int tindex, int bindex, float *no1, float *no2, float *no3, float *m, float *k);
	~Triangle(void);

	float p1[3]; float p2[3]; float p3[3];

private:
	float tex1[2]; float tex2[2]; float tex3[2];
	int tindex; bool is_textured; bool has_bump_map;
	float kd; float ks; float kr;
	float index; float bindex;
	float mat[3];
	float n1[3]; float n2[3]; float n3[3]; float t_normal[3];

public:
	// override virtual functions
	virtual float t(float *p,float *d);
	virtual float tex(float *p,float *d, float *uv);
	virtual float cut_dist(float *p,float *d);
	virtual void transform(float m[3][3]);
	virtual void translate(float *t);
	virtual void normal(float *hit, float *n);
	virtual void partial_derivatives(float *uv, float *duv);
	virtual void material(float *m);
	virtual float get_kd(void);
	virtual float get_ks(void);
	virtual float get_kr(void);
	virtual float get_index(void);
	virtual int get_texture_index(void);
	virtual int get_bump_index(void);
	virtual bool textured(void);
	virtual bool bump_mapping(void);

	// position
	virtual float minX();
	virtual float maxX();
	virtual float minY();
	virtual float maxY();
	virtual float minZ();
	virtual float maxZ();
};
