#pragma once

struct face{
	int v1; int v2; int v3;
	int n1; int n2; int n3;
};

class RIGID_BODY
{
private:
	float Iq[3][3]; 
	float t[3];
	Vector3d *radiiq; int number;
	float dotp(float *a, float *b);
	void crossp(float *a, float *b, float *c);
	void transpose(float m[3][3], float n[3][3]);
	void matrix_mult(float m[3][3], float n[3][3], float p[3][3]);
	void matrix_add(float m[3][3], float n[3][3], float p[3][3]);
	void reorthonorm(float m[3][3]);

public:
	Vector3d *vertices; face *faces; Vector3d *normals;  Vector3d *normalsq; Vector3d xcm; Vector3d xcmq; Vector3d *vels; Vector3d *forces;
	OBB *box; float I[3][3]; Vector3d *radii; float invM;  Vector3d vcm; Vector3d L; float A[3][3]; Vector3d w; 	 
	int nbr_of_faces; int nbr_of_verts; int id; int nbr_of_normals; Vector3d F; Vector3d torque; 
	void set_body(Vector3d *vertices, float nbr, float mass,Vector3d vcm, float A[3][3], Vector3d L);
	void update_all_forces(Vector3d force); void update_individual_forces(Vector3d *forces);
	void update_step(float dt);
	void get_translation(float *t);
	void get_transform(float A[3][3]);

public:
	RIGID_BODY(void);
	RIGID_BODY(Vector3d *vertices, int nbr, face *faces, int nbr_of_faces, Vector3d *normals, int nbr_of_normals, float invM, Vector3d vcm, float A[3][3], Vector3d L, OBB *box, int id);
	~RIGID_BODY(void);
};
